From: Alexander Smirnov <asmirnov@ilbers.de>
To: Henning Schild <henning.schild@siemens.com>
Cc: isar-users@googlegroups.com
Subject: Re: [PATCH v3 4/4] dpkg-base: Update git alternates
Date: Mon, 11 Dec 2017 22:45:15 +0300 [thread overview]
Message-ID: <aaaedb88-d3ec-8d15-f1d3-4a896442af16@ilbers.de> (raw)
In-Reply-To: <20171211185646.02ca7be5@md1pvb1c>
On 12/11/2017 08:56 PM, Henning Schild wrote:
> Well i thought about this again. This is a very nasty workaround for a
> problem this actually is in bitbake.
That's an attempt to solve here and now git-3.0 issue reported by
Christian. So if in general it's not critical problem for now, I could
drop this series.
>
> https://github.com/openembedded/bitbake/blob/ebce92bf8d71f8a6e8af1c6cf6ba335faf9d67c8/lib/bb/fetch2/git.py#L179
>
> That problem should be fixed in bitbake, if they accept patches. The
> "-s" needs to depend on some condition.
>
I'm not sure that this is the best solution. The main idea of using '-s'
was to avoid unnecessary copying of git repos within one build, it costs
disk space and extra time for copying (for example linux.git is about
1GB). So usage of '-s' is quite reasonable here.
Another solution could be deprecate 'downloads' directory and fetch gits
directly to package WORKDIR.
> For Isar i would tell people to fetch tarballs from git servers and
> avoid git://.
This should not be the requirement, because it limits Isar application
area. Not all git repo could be fetched as tarball.
Alex
>
> Henning
>
> Am Mon, 27 Nov 2017 01:00:25 +0300
> schrieb Alexander Smirnov <asmirnov@ilbers.de>:
>
>> Update git alternates to work in buildchroot.
>>
>> Signed-off-by: Alexander Smirnov <asmirnov@ilbers.de>
>> ---
>> meta/classes/dpkg-base.bbclass | 12 ++++++++++++
>> 1 file changed, 12 insertions(+)
>>
>> diff --git a/meta/classes/dpkg-base.bbclass
>> b/meta/classes/dpkg-base.bbclass index 5d7f8b6..6a78a26 100644
>> --- a/meta/classes/dpkg-base.bbclass
>> +++ b/meta/classes/dpkg-base.bbclass
>> @@ -18,12 +18,24 @@ dpkg_runbuild() {
>>
>> # Wrap the function dpkg_runbuild with the bind mount for buildroot
>> do_build() {
>> + if [ -d ${WORKDIR}/git/.git ]; then
>> + OBJ_PATH=$(cat ${WORKDIR}/git/.git/objects/info/alternates)
>> + REPO_PATH=$(dirname $OBJ_PATH)
>> + REPO_NAME=$(basename $REPO_PATH)
>> + echo "/git/$REPO_NAME/objects" >
>> ${WORKDIR}/git/.git/objects/info/alternates
>> + fi
>> +
>> mkdir -p ${BUILDROOT}
>> sudo mount --bind ${WORKDIR} ${BUILDROOT}
>> _do_build_cleanup() {
>> ret=$?
>> sudo umount ${BUILDROOT} 2>/dev/null || true
>> sudo rmdir ${BUILDROOT} 2>/dev/null || true
>> +
>> + if [ -d ${WORKDIR}/git/.git ]; then
>> + echo $OBJ_PATH >
>> ${WORKDIR}/git/.git/objects/info/alternates
>> + fi
>> +
>> (exit $ret) || sudo umount ${BUILDCHROOT_DIR}/git
>> (exit $ret) || bb_exit_handler
>> }
>
--
With best regards,
Alexander Smirnov
ilbers GmbH
Baierbrunner Str. 28c
D-81379 Munich
+49 (89) 122 67 24-0
http://ilbers.de/
Commercial register Munich, HRB 214197
General manager: Baurzhan Ismagulov
next prev parent reply other threads:[~2017-12-11 19:45 UTC|newest]
Thread overview: 11+ messages / expand[flat|nested] mbox.gz Atom feed top
2017-11-26 22:00 [PATCH v3 0/4] Buildchroot prepare/cleanup Alexander Smirnov
2017-11-26 22:00 ` [PATCH v3 1/4] dpkg-base: Fix buildchroot dependency Alexander Smirnov
2017-11-26 22:00 ` [PATCH v3 2/4] image: Add do_rootfs template to image class Alexander Smirnov
2017-11-26 22:00 ` [PATCH v3 3/4] buildchroot: Add prepare and cleanup tasks Alexander Smirnov
2017-11-26 22:00 ` [PATCH v3 4/4] dpkg-base: Update git alternates Alexander Smirnov
2017-12-11 17:56 ` Henning Schild
2017-12-11 19:45 ` Alexander Smirnov [this message]
2017-12-12 11:49 ` Henning Schild
2017-12-12 12:30 ` Alexander Smirnov
2017-12-11 18:03 ` Jan Kiszka
2017-12-11 19:49 ` Alexander Smirnov
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=aaaedb88-d3ec-8d15-f1d3-4a896442af16@ilbers.de \
--to=asmirnov@ilbers.de \
--cc=henning.schild@siemens.com \
--cc=isar-users@googlegroups.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox